/*
  JaVi - JavaVigenere -   A Java implementation of the Vigenere
                                cryptographical  algorithm
        Un'implementazione Java dell'algoritmo di
                                Vigenere per la crittografia
    Copyright (C) 2002 Pierre Blanc
    Pierre Blanc: blanc_teutoburgo@yahoo.it
    http://www.teutoburgo.tk                   (italiano)
    http://teutoburgo.web44.net/indexEn.html   (english)


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    or go to      http://www.gnu.org/copyleft/gpl.html


    Questo  programma   software  libero;   lecito redistribuirlo  o
    modificarlo secondo i termini  della Licenza Pubblica Generica GNU
    come  pubblicata dalla Free  Software Foundation, o la versione 2
    della licenza.
    Questo programma   distribuito nella  speranza che sia  utile, ma
    SENZA  ALCUNA GARANZIA;  senza  neppure la  garanzia implicita  di
    NEGOZIABILIT  o di  APPLICABILIT PER  UN PARTICOLARE  SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Questo  programma deve  essere  distribuito assieme  ad una  copia
    della Licenza Pubblica Generica GNU;  in caso contrario, se ne pu
    ottenere  una scrivendo  alla Free  Software Foundation,  Inc., 59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA  oppure da
    http://www.gnu.org/copyleft/gpl.html


    Un grazie sentito a Roberto detto "Piano Man" per l'importante aiuto.

 */

package JaVi;

/**
 *
 * <p>Title: JaVi BO</p>
 * <p>Description: Questa classe viene usata dall'oggetto Vigenere per contare
 * le frequenze di una singola stringa
<br>
This class is used by the Vigenere object in order to count the frequencies
of a single string</p>
 * <p>Copyright: Copyright (c) 2002 Pierre Blanc</p>
 * <p>Company: Teutoburgo</p>
 * @author Pierre Blanc
 * @version 1.0
 */

public class FrequenzaNijk {

  public FrequenzaNijk(){
  }
/**
 * Il costruttore associa a una stringa la sua frequenza all'interno della
 * chiave
 * <br>
 * The constructor binds a String with its frequency within the key.
 * @param n the String
 * @param f the frequency
 */
  public FrequenzaNijk(String n, double f){
    nijk=n;
    freq=f;
  }

  private String nijk;
  private double freq;

  public String getNijk(){
    return nijk;
  }

  public double getFreq(){
    return freq;
  }

  public void setNijk(String nijk){
    this.nijk=nijk;
  }

  public void setFreq(double freq){
    this.freq=freq;
  }

}